#lang racket

(provide herbie-page)

(define (herbie-page #:title title
		     #:scripts [scripts '()]
		     #:styles [styles '()]
		     #:head-include [other-include-head '()]
		     . body)
  `(html
    (head
     (meta ([charset "utf-8"]))
     (title ,title)
     ,@other-include-head
     ,@(for/list ([script scripts])
         `(script ([src ,script] [type "text/javascript"])))
     (link ([rel "stylesheet"] [type "text/css"] [href "/main.css"]))
     ,@(for/list ([style styles])
         `(link ([rel "stylesheet"] [type "text/css"] [href ,style]))))
    (body
     (header
      (img ([class "logo"] [src "/logo.png"]))
      (h1 ,title))
     ,@body)))
